.\" -*- nroff -*-
.TH sm2dt 1 "3 Mar 2000" "lpsms 0.5.1"
.\" Turn off hyphenation
.hlm 0
.\" Turn off adjustment
.na
.SH NAME
sm2dt - translate a logic program to a default theory
.SH SYNOPSIS
.B sm2dt
.RI "[" options "]"
.RI "[" file "...]"
.\" Back to standard adjustment
.ad
.\" Allow hyphenation, omit if you want no hyphenation in the man page
.hlm 1

.SH DESCRIPTION
The program
.B sm2dt
converts a logic program (in
.B lparse
syntax) to a default theory (in
.B DeReS
syntax).  It also performs simplification and stratification.  It is a driver for
.BR lparse ", " simplify ", " stratify ", and " smdtconv "."

.SH OPTIONS
.TP
.BR "\-t" ", " "\-\-time"
Perform timing.  The CPU time in seconds (as measured by
.BR clock (3))
is displayed to stderr after each phase of processing.  This is the default.
.TP
.BR "\-n" ", " "\-\-no-time"
Do not display timing information.
.TP
.BR "\-c" ", " "\-\-cleanup"
Delete all the intermediate files upon success of the processing.  This
is the default.
.TP
.BR "\-C" ", " "\-\-no-cleanup"
Do not delete intermediate files.
.TP
.BR "\-V" ", " "\-\-verbose"
Display extra status information to stderr.  This flag causes
.B sm2dt
to print a message indicating the command line with which each component is run, as well as some
additional information.
.BR "\-VV" ", " "\-\-more-verbose"
Display extra status information to stderr.  This flag, in addition to providing all the status
messages that
.B "\-V"
does, also runs
.BR simplify ", " stratify ", and " smdtconv
with the
.B "\-V"
flag.
.TP
.BR "\-m" ", " "\-\-messages"
Display only error messages (and possibly timing information, depending on the state of the
.B "\-t"
and
.B "\-n"
flags) to stderr.
.TP
.BR "\-q" ", " "\-\-quiet"
Do not display any messages (other than perhaps timing information) to stderr.
.TP
\fB\-o\fI filename\fR, \fB\-\-output=\fIfilename\fR
Direct the output to the files \fIbase\fB.dc\fR, \fIbase\fB.thc\fR, and \fIbase\fB.dt\fR.  If
.B "\-o"
is not specified, the base defaults to the name of the first input file specified on the command
line, or \(lqsm2dt\(rq if none is specified.
.TP
\fB\-d\fI dir\fR, \fB\-\-directory=\fIdir\fR
Search for
.BR lparse ", " simplify ", " stratify ", and " smdtconv
in the directory
.IR dir .
If a program is not found in
.IR dir ,
it is searched for in the directory from which
.B sm2dt
was run, then in the deafault search path.  Multiple
.B "\-d"
options are cumulative; the directories are searched in the order given.
.TP
\fB\-o\fI program\fR, \fB\-\-parser=\fIprogram\fR
Use
.I program
to ground programs and convert them to
.B smodels 1
format.  The default is \(lq\fClparse -1\fR\(rq.  Other possibilities are \(lq\fCparse\fR\(rq,
\(lq\fClparse -1 -d none\fR\(rq, and \(lq\fClparse -1 -d all\fR\(rq.  If the parser is specified
with
.BR -p ,
the
.B -d
flag is not used to find it.
.TP
.BR
.TP
.BR "\-v" ", " "\-\-version"
Print version information to stdout.  The information indicates the version numbers of
.BR sm2dt ", " liblp ", " lpsms ", " simplify ", " stratify ", and " smdtconv .
.TP
.BR "\-h" ", " "\-\-help"
Display usage information to stdout.

.SH "EXAMPLE USAGE"
\fCsm2dt -V -d/opt/lpsms/bin/ -o prog1 p1-1 p1-2\fR

Combine, simplify, stratify, and convert p1-1 and p1-2 into prog1.dt,
prog1.dc, prog1.thc, with stratification file prog1.str.  Search for
.BR lparse ", " simplify ", " stratify ", and " smdtconv
in /opt/lderes/bin/ before searching in the location of
.B sm2dt
and in $PATH.  Display extra status information to stderr, but have
the other programs display only normal status information, errors,
and timing.

\fCsm2dt -q -n prog2 prog3 prog4\fR

Combine, simplify, stratify, and convert prog2, prog3, and prog4 into
prog2.dt, prog2.thc, and prog2.dc, with stratification file prog1.str.
Display nothing to stderr or stdout.


.SH COMPONENTS
Information on
.BR simplify ", " stratify ", and " smdtconv
can be found in the appropriate man pages (in the same section as this
page\(emsection 1 by default).  Information on
.B lparse
can be found in the
.B lparse
GNU info page, or in the \fClparse/\fR directory of the
.B lpsms
source distribution.

.SH AUTHOR
.RI "Neil Moore <" neil@cs.uky.edu ">"

.B sm2dt
is Copyright \(co 1999 The University of Kentucky.  See the file COPYRIGHT in the
.B lpsms
distribution for details.

.SH BUGS
If one of the processes
.RB ( lparse ", " simplify ", " stratify ", or " smdtconv )
dies, temporary files
.RI ( filename ".out, " filename ".sm, " filename ".sm.simp, or " filename ".ord)"
may be left over.
This is not necessarily a bug: these files can be useful for determining exactly what caused the
process to fail.

None of the programs currently support the
.B smodels 2
format.
.B lparse
can produce both
.B smodels 1
and
.B 2
format programs, so support for the
.B smodels 2
format is not a high priority.

.SH SEE ALSO
.BR simplify "(1), " stratify "(1), " smdtconv "(1), " sderes "(1), " lderes "(1)."

.BR lparse.info ,
in the
.B lparse
source distribution.  This file describes the input format accepted by
.BR sm2dt ,
as well as providing general information over grounding and over logic programming with stable model
semantics.
